/* A Bison parser, made by GNU Bison 1.875c.  */

/* Skeleton parser for Yacc-like parsing with Bison,
   Copyright (C) 1984, 1989, 1990, 2000, 2001, 2002, 2003 Free Software Foundation, Inc.

   This program is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 2, or (at your option)
   any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program; if not, write to the Free Software
   Foundation, Inc., 59 Temple Place - Suite 330,
   Boston, MA 02111-1307, USA.  */

/* As a special exception, when this file is copied by Bison into a
   Bison output file, you may use that output file without restriction.
   This special exception was added by the Free Software Foundation
   in version 1.24 of Bison.  */

/* Written by Richard Stallman by simplifying the original so called
   ``semantic'' parser.  */

/* All symbols defined below should begin with yy or YY, to avoid
   infringing on user name space.  This should be done even for local
   variables, as they might otherwise be expanded by user macros.
   There are some unavoidable exceptions within include files to
   define necessary library symbols; they are noted "INFRINGES ON
   USER NAME SPACE" below.  */

/* Identify Bison output.  */
#define YYBISON 1

/* Skeleton name.  */
#define YYSKELETON_NAME "yacc.c"

/* Pure parsers.  */
#define YYPURE 0

/* Using locations.  */
#define YYLSP_NEEDED 0



/* Tokens.  */
#ifndef YYTOKENTYPE
# define YYTOKENTYPE
   /* Put the tokens into the symbol table, so that GDB and other debuggers
      know about them.  */
   enum yytokentype {
     ALIAS = 258,
     ARRAY = 259,
     AT = 260,
     CASE = 261,
     CONSTANT = 262,
     BEGIN_TOK = 263,
     ELSE = 264,
     ELSIF = 265,
     END = 266,
     FOR = 267,
     FUNCTION = 268,
     GOTO = 269,
     IF = 270,
     IN = 271,
     INOUT = 272,
     IS = 273,
     LOOP = 274,
     MODULE = 275,
     NULL_TOK = 276,
     OF = 277,
     OTHERS = 278,
     PRAGMA = 279,
     PROCEDURE = 280,
     PUBLIC = 281,
     RETURN = 282,
     THEN = 283,
     TO = 284,
     TYPE = 285,
     OUT = 286,
     WHEN = 287,
     WHILE = 288,
     WITH = 289,
     ASM = 290,
     IDENT = 291,
     NUMBER = 292,
     STRING = 293,
     LSH = 294,
     RSH = 295,
     ARROW = 296,
     GREATER_EQUAL = 297,
     LESS_EQUAL = 298,
     EQUAL = 299,
     NOT_EQUAL = 300,
     LOGICAL_AND = 301,
     LOGICAL_OR = 302
   };
#endif
#define ALIAS 258
#define ARRAY 259
#define AT 260
#define CASE 261
#define CONSTANT 262
#define BEGIN_TOK 263
#define ELSE 264
#define ELSIF 265
#define END 266
#define FOR 267
#define FUNCTION 268
#define GOTO 269
#define IF 270
#define IN 271
#define INOUT 272
#define IS 273
#define LOOP 274
#define MODULE 275
#define NULL_TOK 276
#define OF 277
#define OTHERS 278
#define PRAGMA 279
#define PROCEDURE 280
#define PUBLIC 281
#define RETURN 282
#define THEN 283
#define TO 284
#define TYPE 285
#define OUT 286
#define WHEN 287
#define WHILE 288
#define WITH 289
#define ASM 290
#define IDENT 291
#define NUMBER 292
#define STRING 293
#define LSH 294
#define RSH 295
#define ARROW 296
#define GREATER_EQUAL 297
#define LESS_EQUAL 298
#define EQUAL 299
#define NOT_EQUAL 300
#define LOGICAL_AND 301
#define LOGICAL_OR 302




/* Copy the first part of user declarations.  */
#line 1 "parse.y"

/* Parser
   Copyright (C) 2003, 2004
   Craig Franklin

This file is part of gputils.

gputils is free software; you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation; either version 2, or (at your option)
any later version.

gputils is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with gputils; see the file COPYING.  If not, write to
the Free Software Foundation, 59 Temple Place - Suite 330,
Boston, MA 02111-1307, USA.  */

#include "stdhdr.h"

#include "libgputils.h"
#include "gpal.h"
#include "scan.h"

#define YYERROR_VERBOSE

void
yyerror(char *message)
{

  gp_num_errors++;

  if (gp_quiet != 0)
    return;

  assert(message != NULL);
  
  if (state.src) {
    printf("%s:%d:%s\n", state.src->name, state.src->line_number, message);
  } else {
    printf("error: %s\n", message);
  }

  return;
}

int yylex(void);

static gp_linked_list *case_stack = NULL;
static tree *case_ident = NULL;



/* Enabling traces.  */
#ifndef YYDEBUG
# define YYDEBUG 1
#endif

/* Enabling verbose error messages.  */
#ifdef YYERROR_VERBOSE
# undef YYERROR_VERBOSE
# define YYERROR_VERBOSE 1
#else
# define YYERROR_VERBOSE 0
#endif

#if ! defined (YYSTYPE) && ! defined (YYSTYPE_IS_DECLARED)
#line 60 "parse.y"
typedef union YYSTYPE {
  int i;
  struct {
    tree *start;
    tree *end;
  } r;
  char *s;
  tree *t;
  enum node_dir d;
  enum node_op o;
} YYSTYPE;
/* Line 191 of yacc.c.  */
#line 239 "parse.c"
# define yystype YYSTYPE /* obsolescent; will be withdrawn */
# define YYSTYPE_IS_DECLARED 1
# define YYSTYPE_IS_TRIVIAL 1
#endif



/* Copy the second part of user declarations.  */


/* Line 214 of yacc.c.  */
#line 251 "parse.c"

#if ! defined (yyoverflow) || YYERROR_VERBOSE

# ifndef YYFREE
#  define YYFREE free
# endif
# ifndef YYMALLOC
#  define YYMALLOC malloc
# endif

/* The parser invokes alloca or malloc; define the necessary symbols.  */

# ifdef YYSTACK_USE_ALLOCA
#  if YYSTACK_USE_ALLOCA
#   define YYSTACK_ALLOC alloca
#  endif
# else
#  if defined (alloca) || defined (_ALLOCA_H)
#   define YYSTACK_ALLOC alloca
#  else
#   ifdef __GNUC__
#    define YYSTACK_ALLOC __builtin_alloca
#   endif
#  endif
# endif

# ifdef YYSTACK_ALLOC
   /* Pacify GCC's `empty if-body' warning. */
#  define YYSTACK_FREE(Ptr) do { /* empty */; } while (0)
# else
#  if defined (__STDC__) || defined (__cplusplus)
#   include <stdlib.h> /* INFRINGES ON USER NAME SPACE */
#   define YYSIZE_T size_t
#  endif
#  define YYSTACK_ALLOC YYMALLOC
#  define YYSTACK_FREE YYFREE
# endif
#endif /* ! defined (yyoverflow) || YYERROR_VERBOSE */


#if (! defined (yyoverflow) \
     && (! defined (__cplusplus) \
	 || (defined (YYSTYPE_IS_TRIVIAL) && YYSTYPE_IS_TRIVIAL)))

/* A type that is properly aligned for any stack member.  */
union yyalloc
{
  short yyss;
  YYSTYPE yyvs;
  };

/* The size of the maximum gap between one aligned stack and the next.  */
# define YYSTACK_GAP_MAXIMUM (sizeof (union yyalloc) - 1)

/* The size of an array large to enough to hold all stacks, each with
   N elements.  */
# define YYSTACK_BYTES(N) \
     ((N) * (sizeof (short) + sizeof (YYSTYPE))				\
      + YYSTACK_GAP_MAXIMUM)

/* Copy COUNT objects from FROM to TO.  The source and destination do
   not overlap.  */
# ifndef YYCOPY
#  if defined (__GNUC__) && 1 < __GNUC__
#   define YYCOPY(To, From, Count) \
      __builtin_memcpy (To, From, (Count) * sizeof (*(From)))
#  else
#   define YYCOPY(To, From, Count)		\
      do					\
	{					\
	  register YYSIZE_T yyi;		\
	  for (yyi = 0; yyi < (Count); yyi++)	\
	    (To)[yyi] = (From)[yyi];		\
	}					\
      while (0)
#  endif
# endif

/* Relocate STACK from its old location to the new one.  The
   local variables YYSIZE and YYSTACKSIZE give the old and new number of
   elements in the stack, and YYPTR gives the new location of the
   stack.  Advance YYPTR to a properly aligned location for the next
   stack.  */
# define YYSTACK_RELOCATE(Stack)					\
    do									\
      {									\
	YYSIZE_T yynewbytes;						\
	YYCOPY (&yyptr->Stack, Stack, yysize);				\
	Stack = &yyptr->Stack;						\
	yynewbytes = yystacksize * sizeof (*Stack) + YYSTACK_GAP_MAXIMUM; \
	yyptr += yynewbytes / sizeof (*yyptr);				\
      }									\
    while (0)

#endif

#if defined (__STDC__) || defined (__cplusplus)
   typedef signed char yysigned_char;
#else
   typedef short yysigned_char;
#endif

/* YYFINAL -- State number of the termination state. */
#define YYFINAL  2
/* YYLAST -- Last index in YYTABLE.  */
#define YYLAST   281

/* YYNTOKENS -- Number of terminals. */
#define YYNTOKENS  69
/* YYNNTS -- Number of nonterminals. */
#define YYNNTS  45
/* YYNRULES -- Number of rules. */
#define YYNRULES  123
/* YYNRULES -- Number of states. */
#define YYNSTATES  258

/* YYTRANSLATE(YYLEX) -- Bison symbol number corresponding to YYLEX.  */
#define YYUNDEFTOK  2
#define YYMAXUTOK   302

#define YYTRANSLATE(YYX) 						\
  ((unsigned int) (YYX) <= YYMAXUTOK ? yytranslate[YYX] : YYUNDEFTOK)

/* YYTRANSLATE[YYLEX] -- Bison symbol number corresponding to YYLEX.  */
static const unsigned char yytranslate[] =
{
       0,     2,     2,     2,     2,     2,     2,     2,     2,     2,
      63,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,    61,     2,     2,     2,    60,    50,     2,
      64,    65,    58,    56,    66,    57,     2,    59,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,    40,    39,
      48,    55,    49,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,    67,     2,    68,    52,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,    51,     2,    62,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     1,     2,     3,     4,
       5,     6,     7,     8,     9,    10,    11,    12,    13,    14,
      15,    16,    17,    18,    19,    20,    21,    22,    23,    24,
      25,    26,    27,    28,    29,    30,    31,    32,    33,    34,
      35,    36,    37,    38,    41,    42,    43,    44,    45,    46,
      47,    53,    54
};

#if YYDEBUG
/* YYPRHS[YYN] -- Index of the first RHS symbol of rule number YYN in
   YYRHS.  */
static const unsigned short yyprhs[] =
{
       0,     0,     3,     4,     7,    11,    19,    27,    28,    30,
      32,    35,    39,    43,    45,    47,    52,    58,    62,    70,
      76,    84,    93,    98,   104,   107,   113,   122,   130,   132,
     137,   139,   143,   148,   150,   152,   154,   160,   161,   163,
     165,   168,   173,   180,   187,   196,   204,   205,   207,   209,
     212,   215,   218,   222,   226,   229,   237,   246,   247,   256,
     262,   266,   268,   271,   276,   282,   285,   290,   296,   301,
     303,   307,   309,   311,   317,   321,   323,   327,   329,   331,
     335,   337,   339,   343,   345,   347,   349,   353,   355,   357,
     359,   361,   365,   367,   369,   371,   373,   375,   377,   379,
     383,   385,   387,   389,   393,   395,   397,   399,   403,   405,
     407,   409,   411,   414,   416,   418,   420,   422,   424,   426,
     431,   435,   440,   442
};

/* YYRHS -- A `-1'-separated list of the rules' RHS. */
static const yysigned_char yyrhs[] =
{
      70,     0,    -1,    -1,    70,    71,    -1,    70,     1,    63,
      -1,    20,    36,    18,    72,    11,    20,    39,    -1,    26,
      36,    18,    72,    11,    26,    39,    -1,    -1,    73,    -1,
      74,    -1,    74,    73,    -1,    34,    36,    39,    -1,    24,
      96,    39,    -1,    76,    -1,    84,    -1,     3,    36,    36,
      39,    -1,    25,    77,    81,    25,    39,    -1,    25,    77,
      39,    -1,    13,    77,    27,    36,    81,    13,    39,    -1,
      13,    77,    27,    36,    39,    -1,    15,    96,    28,    72,
      11,    15,    39,    -1,    15,    96,    28,    72,    75,    11,
      15,    39,    -1,    10,    96,    28,    72,    -1,    10,    96,
      28,    72,    75,    -1,     9,    72,    -1,    30,    36,    18,
      36,    39,    -1,    30,    36,    18,     4,    94,    22,    36,
      39,    -1,    30,    36,    18,    64,    95,    65,    39,    -1,
      36,    -1,    36,    64,    78,    65,    -1,    79,    -1,    79,
      66,    78,    -1,    36,    40,    80,    36,    -1,    16,    -1,
      17,    -1,    31,    -1,    18,    82,     8,    85,    11,    -1,
      -1,    83,    -1,    84,    -1,    84,    83,    -1,    36,    40,
      36,    39,    -1,    36,    40,    36,     5,    96,    39,    -1,
      36,    40,    36,    55,    96,    39,    -1,    36,    40,    36,
      55,    96,     5,    96,    39,    -1,    36,    40,     7,    36,
      55,    96,    39,    -1,    -1,    86,    -1,    87,    -1,    87,
      86,    -1,    21,    39,    -1,    36,    40,    -1,    14,    36,
      39,    -1,    27,    96,    39,    -1,    35,    39,    -1,    15,
      96,    28,    85,    11,    15,    39,    -1,    15,    96,    28,
      85,    89,    11,    15,    39,    -1,    -1,     6,    36,    88,
      18,    90,    11,     6,    39,    -1,    12,    36,    16,    94,
      93,    -1,    33,    96,    93,    -1,    93,    -1,    96,    39,
      -1,    10,    96,    28,    85,    -1,    10,    96,    28,    85,
      89,    -1,     9,    85,    -1,    32,    91,    43,    85,    -1,
      32,    91,    43,    85,    90,    -1,    32,    23,    43,    85,
      -1,    92,    -1,    92,    51,    91,    -1,    36,    -1,    37,
      -1,    19,    85,    11,    19,    39,    -1,    96,    29,    96,
      -1,    96,    -1,    96,    66,    95,    -1,    97,    -1,    99,
      -1,    97,    98,    99,    -1,    55,    -1,   101,    -1,    99,
     100,   101,    -1,    53,    -1,    54,    -1,   103,    -1,   101,
     102,   103,    -1,    50,    -1,    51,    -1,    52,    -1,   105,
      -1,   103,   104,   105,    -1,    48,    -1,    49,    -1,    46,
      -1,    47,    -1,    44,    -1,    45,    -1,   107,    -1,   105,
     106,   107,    -1,    41,    -1,    42,    -1,   109,    -1,   107,
     108,   109,    -1,    56,    -1,    57,    -1,   111,    -1,   109,
     110,   111,    -1,    58,    -1,    59,    -1,    60,    -1,   113,
      -1,   112,   113,    -1,    57,    -1,    61,    -1,    62,    -1,
      56,    -1,    38,    -1,    36,    -1,    36,    67,    96,    68,
      -1,    36,    64,    65,    -1,    36,    64,    95,    65,    -1,
      37,    -1,    64,    96,    65,    -1
};

/* YYRLINE[YYN] -- source line where rule number YYN was defined.  */
static const unsigned short yyrline[] =
{
       0,   187,   187,   190,   192,   196,   201,   209,   213,   220,
     225,   232,   237,   242,   247,   252,   257,   262,   267,   272,
     277,   282,   289,   295,   300,   308,   314,   320,   328,   333,
     340,   345,   352,   359,   360,   361,   365,   373,   377,   384,
     389,   396,   401,   406,   411,   416,   424,   428,   435,   440,
     447,   452,   457,   462,   467,   472,   477,   483,   482,   503,
     522,   527,   532,   539,   545,   550,   558,   564,   569,   577,
     582,   589,   594,   601,   608,   616,   621,   627,   630,   632,
     638,   641,   643,   649,   650,   653,   655,   661,   662,   663,
     666,   668,   674,   675,   676,   677,   678,   679,   682,   684,
     690,   691,   694,   696,   702,   703,   706,   708,   714,   715,
     716,   719,   721,   727,   728,   729,   730,   733,   738,   743,
     748,   754,   760,   765
};
#endif

#if YYDEBUG || YYERROR_VERBOSE
/* YYTNME[SYMBOL-NUM] -- String name of the symbol SYMBOL-NUM.
   First, the terminals, then, starting at YYNTOKENS, nonterminals. */
static const char *const yytname[] =
{
  "$end", "error", "$undefined", "\"alias\"", "\"array\"", "\"at\"",
  "\"case\"", "\"constant\"", "\"begin\"", "\"else\"", "\"elsif\"",
  "\"end\"", "\"for\"", "\"function\"", "\"goto\"", "\"if\"", "\"in\"",
  "\"inout\"", "\"is\"", "\"loop\"", "\"module\"", "\"null\"", "\"of\"",
  "\"others\"", "\"pragma\"", "\"procedure\"", "\"public\"", "\"return\"",
  "\"then\"", "\"to\"", "\"type\"", "\"out\"", "\"when\"", "\"while\"",
  "\"with\"", "\"asm\"", "\"symbol\"", "\"number\"", "\"string\"", "';'",
  "':'", "\"<<\"", "\">>\"", "\"=>\"", "\">=\"", "\"<=\"", "\"==\"",
  "\"!=\"", "'<'", "'>'", "'&'", "'|'", "'^'", "\"&&\"", "\"||\"", "'='",
  "'+'", "'-'", "'*'", "'/'", "'%'", "'!'", "'~'", "'\\n'", "'('", "')'",
  "','", "'['", "']'", "$accept", "program", "entity", "element_start",
  "element_list", "element", "element_cond", "type", "head", "arg_list",
  "arg", "arg_direction", "body", "decl_start", "decl_block", "decl",
  "statement_start", "statement_block", "statement", "@1", "if_body",
  "case_body", "case_element_list", "case_element", "loop_statement",
  "range", "parameter_list", "expr", "e8", "e8op", "e7", "e7op", "e6",
  "e6op", "e5", "e5op", "e4", "e4op", "e3", "e3op", "e2", "e2op", "e1",
  "e1op", "e0", 0
};
#endif

# ifdef YYPRINT
/* YYTOKNUM[YYLEX-NUM] -- Internal token number corresponding to
   token YYLEX-NUM.  */
static const unsigned short yytoknum[] =
{
       0,   256,   257,   258,   259,   260,   261,   262,   263,   264,
     265,   266,   267,   268,   269,   270,   271,   272,   273,   274,
     275,   276,   277,   278,   279,   280,   281,   282,   283,   284,
     285,   286,   287,   288,   289,   290,   291,   292,   293,    59,
      58,   294,   295,   296,   297,   298,   299,   300,    60,    62,
      38,   124,    94,   301,   302,    61,    43,    45,    42,    47,
      37,    33,   126,    10,    40,    41,    44,    91,    93
};
# endif

/* YYR1[YYN] -- Symbol number of symbol that rule YYN derives.  */
static const unsigned char yyr1[] =
{
       0,    69,    70,    70,    70,    71,    71,    72,    72,    73,
      73,    74,    74,    74,    74,    74,    74,    74,    74,    74,
      74,    74,    75,    75,    75,    76,    76,    76,    77,    77,
      78,    78,    79,    80,    80,    80,    81,    82,    82,    83,
      83,    84,    84,    84,    84,    84,    85,    85,    86,    86,
      87,    87,    87,    87,    87,    87,    87,    88,    87,    87,
      87,    87,    87,    89,    89,    89,    90,    90,    90,    91,
      91,    92,    92,    93,    94,    95,    95,    96,    97,    97,
      98,    99,    99,   100,   100,   101,   101,   102,   102,   102,
     103,   103,   104,   104,   104,   104,   104,   104,   105,   105,
     106,   106,   107,   107,   108,   108,   109,   109,   110,   110,
     110,   111,   111,   112,   112,   112,   112,   113,   113,   113,
     113,   113,   113,   113
};

/* YYR2[YYN] -- Number of symbols composing right hand side of rule YYN.  */
static const unsigned char yyr2[] =
{
       0,     2,     0,     2,     3,     7,     7,     0,     1,     1,
       2,     3,     3,     1,     1,     4,     5,     3,     7,     5,
       7,     8,     4,     5,     2,     5,     8,     7,     1,     4,
       1,     3,     4,     1,     1,     1,     5,     0,     1,     1,
       2,     4,     6,     6,     8,     7,     0,     1,     1,     2,
       2,     2,     3,     3,     2,     7,     8,     0,     8,     5,
       3,     1,     2,     4,     5,     2,     4,     5,     4,     1,
       3,     1,     1,     5,     3,     1,     3,     1,     1,     3,
       1,     1,     3,     1,     1,     1,     3,     1,     1,     1,
       1,     3,     1,     1,     1,     1,     1,     1,     1,     3,
       1,     1,     1,     3,     1,     1,     1,     3,     1,     1,
       1,     1,     2,     1,     1,     1,     1,     1,     1,     4,
       3,     4,     1,     3
};

/* YYDEFACT[STATE-NAME] -- Default rule to reduce with in state
   STATE-NUM when YYTABLE doesn't specify something else to do.  Zero
   means the default is an error.  */
static const unsigned char yydefact[] =
{
       2,     0,     1,     0,     0,     0,     3,     4,     0,     0,
       7,     7,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     8,     9,    13,    14,     0,     0,    28,     0,   118,
     122,   117,   116,   113,   114,   115,     0,     0,    77,    78,
      81,    85,    90,    98,   102,   106,     0,   111,     0,     0,
       0,     0,     0,     0,    10,     0,     0,     0,     0,     0,
       0,     0,     7,    80,     0,    83,    84,     0,    87,    88,
      89,     0,    96,    97,    94,    95,    92,    93,     0,   100,
     101,     0,   104,   105,     0,   108,   109,   110,     0,   112,
      12,    37,    17,     0,     0,    11,     0,     0,     0,     0,
      15,     0,     0,    30,     0,   120,     0,    75,     0,   123,
       0,    79,    82,    86,    91,    99,   103,   107,     0,    38,
      39,     0,     0,     0,     0,     0,     0,    41,     0,     5,
       6,     0,    29,     0,    19,     0,   121,     0,   119,     7,
       0,     0,     0,    46,    40,    16,     0,     0,    25,     0,
       0,     0,     0,    33,    34,    35,     0,    31,     0,    76,
      24,     0,     0,     0,     0,     0,     0,     0,    46,     0,
       0,     0,     0,   118,     0,    47,    48,    61,     0,     0,
       0,     0,     0,    42,     0,    43,    32,    18,     7,    20,
       0,    57,     0,     0,     0,     0,    50,     0,     0,    54,
      51,    36,    49,    62,     0,    74,    27,    45,     0,    22,
      21,     0,     0,    52,    46,     0,    53,    60,    26,    44,
      23,     0,     0,     0,     0,     0,     0,    59,    46,     0,
       0,     0,    73,     0,    71,    72,     0,    69,     0,    65,
       0,     0,     0,    46,    46,     0,     0,    46,    55,     0,
      68,    66,    70,    58,    63,    56,    67,    64
};

/* YYDEFGOTO[NTERM-NUM]. */
static const short yydefgoto[] =
{
      -1,     1,     6,    20,    21,    22,   142,    23,    28,   102,
     103,   156,    93,   118,   119,    24,   174,   175,   176,   211,
     231,   226,   236,   237,   177,   146,   106,   178,    38,    64,
      39,    67,    40,    71,    41,    78,    42,    81,    43,    84,
      44,    88,    45,    46,    47
};

/* YYPACT[STATE-NUM] -- Index in YYTABLE of the portion describing
   STATE-NUM.  */
#define YYPACT_NINF -185
static const short yypact[] =
{
    -185,    32,  -185,   -48,   -28,    -6,  -185,  -185,    30,    39,
      56,    56,    19,    26,    81,    81,    26,    34,    55,    67,
      61,  -185,    56,  -185,  -185,    84,    73,    49,   104,   -55,
    -185,  -185,  -185,  -185,  -185,  -185,    81,   101,    85,    62,
      33,   102,     2,    68,    29,  -185,   -10,  -185,   100,    11,
     123,   105,    -2,   132,  -185,   128,   116,   122,   124,    37,
      81,    94,    56,  -185,    81,  -185,  -185,    81,  -185,  -185,
    -185,    81,  -185,  -185,  -185,  -185,  -185,  -185,    81,  -185,
    -185,    81,  -185,  -185,    81,  -185,  -185,  -185,    81,  -185,
    -185,   126,  -185,   136,     0,  -185,   127,    12,   129,   130,
    -185,   131,    99,   106,    38,  -185,   108,   109,    97,  -185,
      95,    62,    33,   102,     2,    68,    29,  -185,   159,  -185,
     126,   135,    81,   137,    81,   133,    81,  -185,    81,  -185,
    -185,    80,  -185,   122,  -185,   164,  -185,    81,  -185,    56,
      81,   163,   169,     4,  -185,  -185,   160,   152,  -185,   119,
      81,   144,     8,  -185,  -185,  -185,   149,  -185,   147,  -185,
    -185,   161,   148,   175,   155,   156,   157,    81,     4,   158,
      81,    81,   162,    36,   183,  -185,     4,  -185,   165,   166,
      81,   167,   168,  -185,    81,  -185,  -185,  -185,    56,  -185,
     170,  -185,   179,   171,   172,   185,  -185,   173,   180,  -185,
    -185,  -185,  -185,  -185,   174,  -185,  -185,  -185,   177,   118,
    -185,   187,    81,  -185,     4,   184,  -185,  -185,  -185,  -185,
    -185,   176,   180,   111,   178,   -16,   200,  -185,     4,    81,
     199,   207,  -185,   181,  -185,  -185,   182,   186,   213,  -185,
     192,   188,   206,     4,     4,    96,   189,     4,  -185,   190,
    -185,   176,  -185,  -185,   125,  -185,  -185,  -185
};

/* YYPGOTO[NTERM-NUM].  */
static const short yypgoto[] =
{
    -185,  -185,  -185,    -9,   201,  -185,    13,  -185,   210,    98,
    -185,  -185,   134,  -185,   110,   -85,  -165,    57,  -185,  -185,
     -22,   -17,    -5,  -185,  -184,    23,  -113,   -14,  -185,  -185,
     191,  -185,   193,  -185,   194,  -185,   195,  -185,   196,  -185,
     197,  -185,   151,  -185,   198
};

/* YYTABLE[YYPACT[STATE-NUM]].  What to do in state STATE-NUM.  If
   positive, shift that token.  If negative, reduce the rule which
   number is the opposite.  If zero, do what YYDEFACT says.
   If YYTABLE_NINF, syntax error.  */
#define YYTABLE_NINF -1
static const unsigned short yytable[] =
{
      37,    48,    25,   195,   122,    96,   120,   233,     8,    59,
     164,   149,    60,   184,   217,     7,   165,   126,   166,   167,
     234,   235,    61,   168,   159,   169,    29,    30,    31,    91,
       9,   170,     2,     3,    97,   120,   123,   171,   227,   172,
     173,    30,    31,    79,    80,   107,   108,   185,    10,   223,
      92,   127,     4,   110,    36,    26,    91,    11,     5,    12,
      32,    33,    27,   239,   124,    34,    35,   128,    36,    13,
      50,    14,    53,    29,    30,    31,   200,   134,   250,   251,
      15,    16,   254,    68,    69,    70,    17,    85,    86,    87,
      18,    51,    19,    32,    33,    55,   153,   154,    34,    35,
      59,    36,   105,    60,   139,   140,   141,    52,   147,    56,
     107,   155,   151,    57,   152,    65,    66,    29,    30,    31,
     228,   229,   230,   107,    82,    83,   161,   139,   140,    62,
     160,    58,   234,   235,   228,   229,   182,    32,    33,    90,
      63,    94,    34,    35,    95,    36,    72,    73,    74,    75,
      76,    77,    98,   194,    99,   100,   197,   198,   101,   109,
     104,   121,    19,   125,   132,   138,   205,   143,   129,   130,
     208,   131,   133,   136,   145,   137,   148,   158,   162,   209,
     163,   180,   179,   183,   181,   186,   187,   189,   150,   188,
     190,   191,   192,   193,   201,   212,   215,   196,   147,   168,
     214,   199,   204,   224,   203,   221,   206,   207,   225,   210,
     213,   238,   216,   218,   241,   240,   219,   232,   242,   246,
     247,   249,   220,    54,   243,   244,    49,   248,   253,   255,
     144,   157,   257,   202,   256,   222,     0,   245,   135,   117,
     252,     0,     0,     0,    89,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   111,     0,     0,     0,     0,
     112,     0,     0,     0,     0,   113,     0,     0,     0,     0,
       0,     0,     0,   114,     0,     0,     0,   115,     0,     0,
       0,   116
};

static const short yycheck[] =
{
      14,    15,    11,   168,     4,     7,    91,    23,    36,    64,
       6,   124,    67,     5,   198,    63,    12,     5,    14,    15,
      36,    37,    36,    19,   137,    21,    36,    37,    38,    18,
      36,    27,     0,     1,    36,   120,    36,    33,   222,    35,
      36,    37,    38,    41,    42,    59,    60,    39,    18,   214,
      39,    39,    20,    62,    64,    36,    18,    18,    26,     3,
      56,    57,    36,   228,    64,    61,    62,    55,    64,    13,
      36,    15,    11,    36,    37,    38,    40,    39,   243,   244,
      24,    25,   247,    50,    51,    52,    30,    58,    59,    60,
      34,    36,    36,    56,    57,    11,    16,    17,    61,    62,
      64,    64,    65,    67,     9,    10,    11,    40,   122,    36,
     124,    31,   126,    64,   128,    53,    54,    36,    37,    38,
       9,    10,    11,   137,    56,    57,   140,     9,    10,    28,
     139,    27,    36,    37,     9,    10,   150,    56,    57,    39,
      55,    18,    61,    62,    39,    64,    44,    45,    46,    47,
      48,    49,    20,   167,    26,    39,   170,   171,    36,    65,
      36,    25,    36,    36,    65,    68,   180,     8,    39,    39,
     184,    40,    66,    65,    39,    66,    39,    13,    15,   188,
      11,    29,    22,    39,    65,    36,    39,    39,    55,    28,
      15,    36,    36,    36,    11,    16,    11,    39,   212,    19,
      28,    39,    36,    19,    39,    18,    39,    39,    32,    39,
      39,    11,    39,    39,    15,   229,    39,    39,    11,     6,
      28,    15,   209,    22,    43,    43,    16,    39,    39,    39,
     120,   133,   254,   176,   251,   212,    -1,    51,   104,    88,
     245,    -1,    -1,    -1,    46,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    64,    -1,    -1,    -1,    -1,
      67,    -1,    -1,    -1,    -1,    71,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    78,    -1,    -1,    -1,    81,    -1,    -1,
      -1,    84
};

/* YYSTOS[STATE-NUM] -- The (internal number of the) accessing
   symbol of state STATE-NUM.  */
static const unsigned char yystos[] =
{
       0,    70,     0,     1,    20,    26,    71,    63,    36,    36,
      18,    18,     3,    13,    15,    24,    25,    30,    34,    36,
      72,    73,    74,    76,    84,    72,    36,    36,    77,    36,
      37,    38,    56,    57,    61,    62,    64,    96,    97,    99,
     101,   103,   105,   107,   109,   111,   112,   113,    96,    77,
      36,    36,    40,    11,    73,    11,    36,    64,    27,    64,
      67,    96,    28,    55,    98,    53,    54,   100,    50,    51,
      52,   102,    44,    45,    46,    47,    48,    49,   104,    41,
      42,   106,    56,    57,   108,    58,    59,    60,   110,   113,
      39,    18,    39,    81,    18,    39,     7,    36,    20,    26,
      39,    36,    78,    79,    36,    65,    95,    96,    96,    65,
      72,    99,   101,   103,   105,   107,   109,   111,    82,    83,
      84,    25,     4,    36,    64,    36,     5,    39,    55,    39,
      39,    40,    65,    66,    39,    81,    65,    66,    68,     9,
      10,    11,    75,     8,    83,    39,    94,    96,    39,    95,
      55,    96,    96,    16,    17,    31,    80,    78,    13,    95,
      72,    96,    15,    11,     6,    12,    14,    15,    19,    21,
      27,    33,    35,    36,    85,    86,    87,    93,    96,    22,
      29,    65,    96,    39,     5,    39,    36,    39,    28,    39,
      15,    36,    36,    36,    96,    85,    39,    96,    96,    39,
      40,    11,    86,    39,    36,    96,    39,    39,    96,    72,
      39,    88,    16,    39,    28,    11,    39,    93,    39,    39,
      75,    18,    94,    85,    19,    32,    90,    93,     9,    10,
      11,    89,    39,    23,    36,    37,    91,    92,    11,    85,
      96,    15,    11,    43,    43,    51,     6,    28,    39,    15,
      85,    85,    91,    39,    85,    39,    90,    89
};

#if ! defined (YYSIZE_T) && defined (__SIZE_TYPE__)
# define YYSIZE_T __SIZE_TYPE__
#endif
#if ! defined (YYSIZE_T) && defined (size_t)
# define YYSIZE_T size_t
#endif
#if ! defined (YYSIZE_T)
# if defined (__STDC__) || defined (__cplusplus)
#  include <stddef.h> /* INFRINGES ON USER NAME SPACE */
#  define YYSIZE_T size_t
# endif
#endif
#if ! defined (YYSIZE_T)
# define YYSIZE_T unsigned int
#endif

#define yyerrok		(yyerrstatus = 0)
#define yyclearin	(yychar = YYEMPTY)
#define YYEMPTY		(-2)
#define YYEOF		0

#define YYACCEPT	goto yyacceptlab
#define YYABORT		goto yyabortlab
#define YYERROR		goto yyerrorlab


/* Like YYERROR except do call yyerror.  This remains here temporarily
   to ease the transition to the new meaning of YYERROR, for GCC.
   Once GCC version 2 has supplanted version 1, this can go.  */

#define YYFAIL		goto yyerrlab

#define YYRECOVERING()  (!!yyerrstatus)

#define YYBACKUP(Token, Value)					\
do								\
  if (yychar == YYEMPTY && yylen == 1)				\
    {								\
      yychar = (Token);						\
      yylval = (Value);						\
      yytoken = YYTRANSLATE (yychar);				\
      YYPOPSTACK;						\
      goto yybackup;						\
    }								\
  else								\
    { 								\
      yyerror ("syntax error: cannot back up");\
      YYERROR;							\
    }								\
while (0)

#define YYTERROR	1
#define YYERRCODE	256

/* YYLLOC_DEFAULT -- Compute the default location (before the actions
   are run).  */

#ifndef YYLLOC_DEFAULT
# define YYLLOC_DEFAULT(Current, Rhs, N)		\
   ((Current).first_line   = (Rhs)[1].first_line,	\
    (Current).first_column = (Rhs)[1].first_column,	\
    (Current).last_line    = (Rhs)[N].last_line,	\
    (Current).last_column  = (Rhs)[N].last_column)
#endif

/* YYLEX -- calling `yylex' with the right arguments.  */

#ifdef YYLEX_PARAM
# define YYLEX yylex (YYLEX_PARAM)
#else
# define YYLEX yylex ()
#endif

/* Enable debugging if requested.  */
#if YYDEBUG

# ifndef YYFPRINTF
#  include <stdio.h> /* INFRINGES ON USER NAME SPACE */
#  define YYFPRINTF fprintf
# endif

# define YYDPRINTF(Args)			\
do {						\
  if (yydebug)					\
    YYFPRINTF Args;				\
} while (0)

# define YYDSYMPRINT(Args)			\
do {						\
  if (yydebug)					\
    yysymprint Args;				\
} while (0)

# define YYDSYMPRINTF(Title, Token, Value, Location)		\
do {								\
  if (yydebug)							\
    {								\
      YYFPRINTF (stderr, "%s ", Title);				\
      yysymprint (stderr, 					\
                  Token, Value);	\
      YYFPRINTF (stderr, "\n");					\
    }								\
} while (0)

/*------------------------------------------------------------------.
| yy_stack_print -- Print the state stack from its BOTTOM up to its |
| TOP (included).                                                   |
`------------------------------------------------------------------*/

#if defined (__STDC__) || defined (__cplusplus)
static void
yy_stack_print (short *bottom, short *top)
#else
static void
yy_stack_print (bottom, top)
    short *bottom;
    short *top;
#endif
{
  YYFPRINTF (stderr, "Stack now");
  for (/* Nothing. */; bottom <= top; ++bottom)
    YYFPRINTF (stderr, " %d", *bottom);
  YYFPRINTF (stderr, "\n");
}

# define YY_STACK_PRINT(Bottom, Top)				\
do {								\
  if (yydebug)							\
    yy_stack_print ((Bottom), (Top));				\
} while (0)


/*------------------------------------------------.
| Report that the YYRULE is going to be reduced.  |
`------------------------------------------------*/

#if defined (__STDC__) || defined (__cplusplus)
static void
yy_reduce_print (int yyrule)
#else
static void
yy_reduce_print (yyrule)
    int yyrule;
#endif
{
  int yyi;
  unsigned int yylno = yyrline[yyrule];
  YYFPRINTF (stderr, "Reducing stack by rule %d (line %u), ",
             yyrule - 1, yylno);
  /* Print the symbols being reduced, and their result.  */
  for (yyi = yyprhs[yyrule]; 0 <= yyrhs[yyi]; yyi++)
    YYFPRINTF (stderr, "%s ", yytname [yyrhs[yyi]]);
  YYFPRINTF (stderr, "-> %s\n", yytname [yyr1[yyrule]]);
}

# define YY_REDUCE_PRINT(Rule)		\
do {					\
  if (yydebug)				\
    yy_reduce_print (Rule);		\
} while (0)

/* Nonzero means print parse trace.  It is left uninitialized so that
   multiple parsers can coexist.  */
int yydebug;
#else /* !YYDEBUG */
# define YYDPRINTF(Args)
# define YYDSYMPRINT(Args)
# define YYDSYMPRINTF(Title, Token, Value, Location)
# define YY_STACK_PRINT(Bottom, Top)
# define YY_REDUCE_PRINT(Rule)
#endif /* !YYDEBUG */


/* YYINITDEPTH -- initial size of the parser's stacks.  */
#ifndef	YYINITDEPTH
# define YYINITDEPTH 200
#endif

/* YYMAXDEPTH -- maximum size the stacks can grow to (effective only
   if the built-in stack extension method is used).

   Do not make this value too large; the results are undefined if
   SIZE_MAX < YYSTACK_BYTES (YYMAXDEPTH)
   evaluated with infinite-precision integer arithmetic.  */

#if defined (YYMAXDEPTH) && YYMAXDEPTH == 0
# undef YYMAXDEPTH
#endif

#ifndef YYMAXDEPTH
# define YYMAXDEPTH 10000
#endif



#if YYERROR_VERBOSE

# ifndef yystrlen
#  if defined (__GLIBC__) && defined (_STRING_H)
#   define yystrlen strlen
#  else
/* Return the length of YYSTR.  */
static YYSIZE_T
#   if defined (__STDC__) || defined (__cplusplus)
yystrlen (const char *yystr)
#   else
yystrlen (yystr)
     const char *yystr;
#   endif
{
  register const char *yys = yystr;

  while (*yys++ != '\0')
    continue;

  return yys - yystr - 1;
}
#  endif
# endif

# ifndef yystpcpy
#  if defined (__GLIBC__) && defined (_STRING_H) && defined (_GNU_SOURCE)
#   define yystpcpy stpcpy
#  else
/* Copy YYSRC to YYDEST, returning the address of the terminating '\0' in
   YYDEST.  */
static char *
#   if defined (__STDC__) || defined (__cplusplus)
yystpcpy (char *yydest, const char *yysrc)
#   else
yystpcpy (yydest, yysrc)
     char *yydest;
     const char *yysrc;
#   endif
{
  register char *yyd = yydest;
  register const char *yys = yysrc;

  while ((*yyd++ = *yys++) != '\0')
    continue;

  return yyd - 1;
}
#  endif
# endif

#endif /* !YYERROR_VERBOSE */



#if YYDEBUG
/*--------------------------------.
| Print this symbol on YYOUTPUT.  |
`--------------------------------*/

#if defined (__STDC__) || defined (__cplusplus)
static void
yysymprint (FILE *yyoutput, int yytype, YYSTYPE *yyvaluep)
#else
static void
yysymprint (yyoutput, yytype, yyvaluep)
    FILE *yyoutput;
    int yytype;
    YYSTYPE *yyvaluep;
#endif
{
  /* Pacify ``unused variable'' warnings.  */
  (void) yyvaluep;

  if (yytype < YYNTOKENS)
    {
      YYFPRINTF (yyoutput, "token %s (", yytname[yytype]);
# ifdef YYPRINT
      YYPRINT (yyoutput, yytoknum[yytype], *yyvaluep);
# endif
    }
  else
    YYFPRINTF (yyoutput, "nterm %s (", yytname[yytype]);

  switch (yytype)
    {
      default:
        break;
    }
  YYFPRINTF (yyoutput, ")");
}

#endif /* ! YYDEBUG */
/*-----------------------------------------------.
| Release the memory associated to this symbol.  |
`-----------------------------------------------*/

#if defined (__STDC__) || defined (__cplusplus)
static void
yydestruct (int yytype, YYSTYPE *yyvaluep)
#else
static void
yydestruct (yytype, yyvaluep)
    int yytype;
    YYSTYPE *yyvaluep;
#endif
{
  /* Pacify ``unused variable'' warnings.  */
  (void) yyvaluep;

  switch (yytype)
    {

      default:
        break;
    }
}


/* Prevent warnings from -Wmissing-prototypes.  */

#ifdef YYPARSE_PARAM
# if defined (__STDC__) || defined (__cplusplus)
int yyparse (void *YYPARSE_PARAM);
# else
int yyparse ();
# endif
#else /* ! YYPARSE_PARAM */
#if defined (__STDC__) || defined (__cplusplus)
int yyparse (void);
#else
int yyparse ();
#endif
#endif /* ! YYPARSE_PARAM */



/* The lookahead symbol.  */
int yychar;

/* The semantic value of the lookahead symbol.  */
YYSTYPE yylval;

/* Number of syntax errors so far.  */
int yynerrs;



/*----------.
| yyparse.  |
`----------*/

#ifdef YYPARSE_PARAM
# if defined (__STDC__) || defined (__cplusplus)
int yyparse (void *YYPARSE_PARAM)
# else
int yyparse (YYPARSE_PARAM)
  void *YYPARSE_PARAM;
# endif
#else /* ! YYPARSE_PARAM */
#if defined (__STDC__) || defined (__cplusplus)
int
yyparse (void)
#else
int
yyparse ()

#endif
#endif
{
  
  register int yystate;
  register int yyn;
  int yyresult;
  /* Number of tokens to shift before error messages enabled.  */
  int yyerrstatus;
  /* Lookahead token as an internal (translated) token number.  */
  int yytoken = 0;

  /* Three stacks and their tools:
     `yyss': related to states,
     `yyvs': related to semantic values,
     `yyls': related to locations.

     Refer to the stacks thru separate pointers, to allow yyoverflow
     to reallocate them elsewhere.  */

  /* The state stack.  */
  short	yyssa[YYINITDEPTH];
  short *yyss = yyssa;
  register short *yyssp;

  /* The semantic value stack.  */
  YYSTYPE yyvsa[YYINITDEPTH];
  YYSTYPE *yyvs = yyvsa;
  register YYSTYPE *yyvsp;



#define YYPOPSTACK   (yyvsp--, yyssp--)

  YYSIZE_T yystacksize = YYINITDEPTH;

  /* The variables used to return semantic value and location from the
     action routines.  */
  YYSTYPE yyval;


  /* When reducing, the number of symbols on the RHS of the reduced
     rule.  */
  int yylen;

  YYDPRINTF ((stderr, "Starting parse\n"));

  yystate = 0;
  yyerrstatus = 0;
  yynerrs = 0;
  yychar = YYEMPTY;		/* Cause a token to be read.  */

  /* Initialize stack pointers.
     Waste one element of value and location stack
     so that they stay on the same level as the state stack.
     The wasted elements are never initialized.  */

  yyssp = yyss;
  yyvsp = yyvs;

  goto yysetstate;

/*------------------------------------------------------------.
| yynewstate -- Push a new state, which is found in yystate.  |
`------------------------------------------------------------*/
 yynewstate:
  /* In all cases, when you get here, the value and location stacks
     have just been pushed. so pushing a state here evens the stacks.
     */
  yyssp++;

 yysetstate:
  *yyssp = yystate;

  if (yyss + yystacksize - 1 <= yyssp)
    {
      /* Get the current used size of the three stacks, in elements.  */
      YYSIZE_T yysize = yyssp - yyss + 1;

#ifdef yyoverflow
      {
	/* Give user a chance to reallocate the stack. Use copies of
	   these so that the &'s don't force the real ones into
	   memory.  */
	YYSTYPE *yyvs1 = yyvs;
	short *yyss1 = yyss;


	/* Each stack pointer address is followed by the size of the
	   data in use in that stack, in bytes.  This used to be a
	   conditional around just the two extra args, but that might
	   be undefined if yyoverflow is a macro.  */
	yyoverflow ("parser stack overflow",
		    &yyss1, yysize * sizeof (*yyssp),
		    &yyvs1, yysize * sizeof (*yyvsp),

		    &yystacksize);

	yyss = yyss1;
	yyvs = yyvs1;
      }
#else /* no yyoverflow */
# ifndef YYSTACK_RELOCATE
      goto yyoverflowlab;
# else
      /* Extend the stack our own way.  */
      if (YYMAXDEPTH <= yystacksize)
	goto yyoverflowlab;
      yystacksize *= 2;
      if (YYMAXDEPTH < yystacksize)
	yystacksize = YYMAXDEPTH;

      {
	short *yyss1 = yyss;
	union yyalloc *yyptr =
	  (union yyalloc *) YYSTACK_ALLOC (YYSTACK_BYTES (yystacksize));
	if (! yyptr)
	  goto yyoverflowlab;
	YYSTACK_RELOCATE (yyss);
	YYSTACK_RELOCATE (yyvs);

#  undef YYSTACK_RELOCATE
	if (yyss1 != yyssa)
	  YYSTACK_FREE (yyss1);
      }
# endif
#endif /* no yyoverflow */

      yyssp = yyss + yysize - 1;
      yyvsp = yyvs + yysize - 1;


      YYDPRINTF ((stderr, "Stack size increased to %lu\n",
		  (unsigned long int) yystacksize));

      if (yyss + yystacksize - 1 <= yyssp)
	YYABORT;
    }

  YYDPRINTF ((stderr, "Entering state %d\n", yystate));

  goto yybackup;

/*-----------.
| yybackup.  |
`-----------*/
yybackup:

/* Do appropriate processing given the current state.  */
/* Read a lookahead token if we need one and don't already have one.  */
/* yyresume: */

  /* First try to decide what to do without reference to lookahead token.  */

  yyn = yypact[yystate];
  if (yyn == YYPACT_NINF)
    goto yydefault;

  /* Not known => get a lookahead token if don't already have one.  */

  /* YYCHAR is either YYEMPTY or YYEOF or a valid lookahead symbol.  */
  if (yychar == YYEMPTY)
    {
      YYDPRINTF ((stderr, "Reading a token: "));
      yychar = YYLEX;
    }

  if (yychar <= YYEOF)
    {
      yychar = yytoken = YYEOF;
      YYDPRINTF ((stderr, "Now at end of input.\n"));
    }
  else
    {
      yytoken = YYTRANSLATE (yychar);
      YYDSYMPRINTF ("Next token is", yytoken, &yylval, &yylloc);
    }

  /* If the proper action on seeing token YYTOKEN is to reduce or to
     detect an error, take that action.  */
  yyn += yytoken;
  if (yyn < 0 || YYLAST < yyn || yycheck[yyn] != yytoken)
    goto yydefault;
  yyn = yytable[yyn];
  if (yyn <= 0)
    {
      if (yyn == 0 || yyn == YYTABLE_NINF)
	goto yyerrlab;
      yyn = -yyn;
      goto yyreduce;
    }

  if (yyn == YYFINAL)
    YYACCEPT;

  /* Shift the lookahead token.  */
  YYDPRINTF ((stderr, "Shifting token %s, ", yytname[yytoken]));

  /* Discard the token being shifted unless it is eof.  */
  if (yychar != YYEOF)
    yychar = YYEMPTY;

  *++yyvsp = yylval;


  /* Count tokens shifted since error; after three, turn off error
     status.  */
  if (yyerrstatus)
    yyerrstatus--;

  yystate = yyn;
  goto yynewstate;


/*-----------------------------------------------------------.
| yydefault -- do the default action for the current state.  |
`-----------------------------------------------------------*/
yydefault:
  yyn = yydefact[yystate];
  if (yyn == 0)
    goto yyerrlab;
  goto yyreduce;


/*-----------------------------.
| yyreduce -- Do a reduction.  |
`-----------------------------*/
yyreduce:
  /* yyn is the number of a rule to reduce with.  */
  yylen = yyr2[yyn];

  /* If YYLEN is nonzero, implement the default value of the action:
     `$$ = $1'.

     Otherwise, the following line sets YYVAL to garbage.
     This behavior is undocumented and Bison
     users should not rely upon it.  Assigning to YYVAL
     unconditionally makes the parser a bit smaller, and it avoids a
     GCC warning that YYVAL may be used uninitialized.  */
  yyval = yyvsp[1-yylen];


  YY_REDUCE_PRINT (yyn);
  switch (yyn)
    {
        case 5:
#line 197 "parse.y"
    {
	  add_entity(mk_file(yyvsp[-3].t, yyvsp[-5].s, source_module));
	}
    break;

  case 6:
#line 202 "parse.y"
    {
	  add_entity(mk_file(yyvsp[-3].t, yyvsp[-5].s, source_with));
	}
    break;

  case 7:
#line 209 "parse.y"
    {
	  yyval.t = NULL;
	}
    break;

  case 8:
#line 214 "parse.y"
    {
          yyval.t = yyvsp[0].t;
	}
    break;

  case 9:
#line 221 "parse.y"
    {
	  yyval.t = node_list(yyvsp[0].t, NULL);
	}
    break;

  case 10:
#line 226 "parse.y"
    {
	  yyval.t = node_list(yyvsp[-1].t, yyvsp[0].t);
	}
    break;

  case 11:
#line 233 "parse.y"
    {
	  yyval.t = mk_with(yyvsp[-1].s);
	}
    break;

  case 12:
#line 238 "parse.y"
    {
	  yyval.t = mk_pragma(yyvsp[-1].t);
	}
    break;

  case 13:
#line 243 "parse.y"
    {
	  yyval.t = yyvsp[0].t;
        }
    break;

  case 14:
#line 248 "parse.y"
    {
	  yyval.t = yyvsp[0].t;
        }
    break;

  case 15:
#line 253 "parse.y"
    {
	  yyval.t = mk_alias(yyvsp[-2].s, yyvsp[-1].s);
        }
    break;

  case 16:
#line 258 "parse.y"
    { 
	  yyval.t = mk_proc(yyvsp[-3].t, yyvsp[-2].t);
     	}
    break;

  case 17:
#line 263 "parse.y"
    { 
	  yyval.t = mk_proc(yyvsp[-1].t, NULL);
	}
    break;

  case 18:
#line 268 "parse.y"
    { 
	  yyval.t = mk_func(yyvsp[-5].t, yyvsp[-3].s, yyvsp[-2].t);
	}
    break;

  case 19:
#line 273 "parse.y"
    { 
	  yyval.t = mk_func(yyvsp[-3].t, yyvsp[-1].s, NULL);
	}
    break;

  case 20:
#line 278 "parse.y"
    {
	  yyval.t = mk_cond(yyvsp[-5].t, yyvsp[-3].t, NULL);
	}
    break;

  case 21:
#line 283 "parse.y"
    {
	  yyval.t = mk_cond(yyvsp[-6].t, yyvsp[-4].t, yyvsp[-3].t);
	}
    break;

  case 22:
#line 290 "parse.y"
    {
	  /* last statement is elsif */
	  yyval.t = mk_cond(yyvsp[-2].t, yyvsp[0].t, NULL);
	}
    break;

  case 23:
#line 296 "parse.y"
    {
	  yyval.t = mk_cond(yyvsp[-3].t, yyvsp[-1].t, yyvsp[0].t);
	}
    break;

  case 24:
#line 301 "parse.y"
    {
	  /* last statement is else */
	  yyval.t = mk_cond(NULL, yyvsp[0].t, NULL);
	}
    break;

  case 25:
#line 309 "parse.y"
    {
	  /* alias */
	  yyval.t = mk_type(yyvsp[-3].s, NULL, NULL, NULL, yyvsp[-1].s);
        }
    break;

  case 26:
#line 315 "parse.y"
    {
	  /* array */
	  yyval.t = mk_type(yyvsp[-6].s, yyvsp[-3].r.start, yyvsp[-3].r.end, NULL, yyvsp[-1].s);
        }
    break;

  case 27:
#line 321 "parse.y"
    {
	  /* enumerated type */
	  yyval.t = mk_type(yyvsp[-5].s, NULL, NULL, yyvsp[-2].t, NULL);
        }
    break;

  case 28:
#line 329 "parse.y"
    {
 	  yyval.t = mk_head(yyvsp[0].s, NULL);
     	}
    break;

  case 29:
#line 334 "parse.y"
    {
 	  yyval.t = mk_head(yyvsp[-3].s, yyvsp[-1].t);
     	}
    break;

  case 30:
#line 341 "parse.y"
    {
	  yyval.t = node_list(yyvsp[0].t, NULL);
	}
    break;

  case 31:
#line 346 "parse.y"
    {
	  yyval.t = node_list(yyvsp[-2].t, yyvsp[0].t);
	}
    break;

  case 32:
#line 353 "parse.y"
    {	  
	  yyval.t = mk_arg(yyvsp[-3].s, yyvsp[-1].d, yyvsp[0].s);
        }
    break;

  case 33:
#line 359 "parse.y"
    { yyval.d = dir_in; }
    break;

  case 34:
#line 360 "parse.y"
    { yyval.d = dir_inout; }
    break;

  case 35:
#line 361 "parse.y"
    { yyval.d = dir_out; }
    break;

  case 36:
#line 366 "parse.y"
    {
	  yyval.t = mk_body(yyvsp[-3].t, yyvsp[-1].t);
	}
    break;

  case 37:
#line 373 "parse.y"
    {
	  yyval.t = NULL;
	}
    break;

  case 38:
#line 378 "parse.y"
    {
          yyval.t = yyvsp[0].t;
	}
    break;

  case 39:
#line 385 "parse.y"
    {
	  yyval.t = node_list(yyvsp[0].t, NULL);
	}
    break;

  case 40:
#line 390 "parse.y"
    {
	  yyval.t = node_list(yyvsp[-1].t, yyvsp[0].t);
	}
    break;

  case 41:
#line 397 "parse.y"
    { 
	  yyval.t = mk_decl(yyvsp[-3].s, false, yyvsp[-1].s, NULL, NULL);
        }
    break;

  case 42:
#line 402 "parse.y"
    { 
	  yyval.t = mk_decl(yyvsp[-5].s, false, yyvsp[-3].s, NULL, yyvsp[-1].t);
        }
    break;

  case 43:
#line 407 "parse.y"
    { 
	  yyval.t = mk_decl(yyvsp[-5].s, false, yyvsp[-3].s, yyvsp[-1].t, NULL);
        }
    break;

  case 44:
#line 412 "parse.y"
    { 
	  yyval.t = mk_decl(yyvsp[-7].s, false, yyvsp[-5].s, yyvsp[-3].t, yyvsp[-1].t);
        }
    break;

  case 45:
#line 417 "parse.y"
    { 
	  yyval.t = mk_decl(yyvsp[-6].s, true, yyvsp[-3].s, yyvsp[-1].t, NULL);
        }
    break;

  case 46:
#line 424 "parse.y"
    {
	  yyval.t = NULL;
	}
    break;

  case 47:
#line 429 "parse.y"
    {
	  yyval.t = yyvsp[0].t;
	}
    break;

  case 48:
#line 436 "parse.y"
    {
	  yyval.t = node_list(yyvsp[0].t, NULL);
	}
    break;

  case 49:
#line 441 "parse.y"
    {
	  yyval.t = node_list(yyvsp[-1].t, yyvsp[0].t);
	}
    break;

  case 50:
#line 448 "parse.y"
    {
	  yyval.t = mk_assembly(strdup("  nop"));
	}
    break;

  case 51:
#line 453 "parse.y"
    {
	  yyval.t = mk_label(yyvsp[-1].s);
	}
    break;

  case 52:
#line 458 "parse.y"
    {
	  yyval.t = mk_goto(yyvsp[-1].s);
	}
    break;

  case 53:
#line 463 "parse.y"
    {
	  yyval.t = mk_return(yyvsp[-1].t);
	}
    break;

  case 54:
#line 468 "parse.y"
    {
	  yyval.t = mk_assembly(yyvsp[-1].s);
	}
    break;

  case 55:
#line 473 "parse.y"
    {
	  yyval.t = mk_cond(yyvsp[-5].t, yyvsp[-3].t, NULL);
	}
    break;

  case 56:
#line 478 "parse.y"
    {
	  yyval.t = mk_cond(yyvsp[-6].t, yyvsp[-4].t, yyvsp[-3].t);
	}
    break;

  case 57:
#line 483 "parse.y"
    {
          gp_linked_list *new = gp_list_make();

          new->prev = case_stack;
          case_stack = new;

	  case_ident = mk_symbol(yyvsp[0].s, NULL);
          gp_list_annotate(case_stack, case_ident);
	}
    break;

  case 58:
#line 493 "parse.y"
    {
	  yyval.t = yyvsp[-3].t;
          case_stack = case_stack->prev;
          if (case_stack) {
            case_ident = gp_list_get(case_stack);
          } else {
            case_ident = NULL;
          }
	}
    break;

  case 59:
#line 504 "parse.y"
    {
	  tree *init;
          tree *exit;
          tree *increment;
          
          /* IDENT = range.start; */
          init = mk_binop(op_assign, mk_symbol(yyvsp[-3].s, NULL), yyvsp[-1].r.start);
          
          /* IDENT = IDENT + 1; */
          increment = mk_binop(op_assign, mk_symbol(yyvsp[-3].s, NULL), 
                               mk_binop(op_add, mk_symbol(yyvsp[-3].s, NULL), mk_constant(1)));
          
          /* while (IDENT <= range.end) then loop */
          exit = mk_binop(op_lte, mk_symbol(yyvsp[-3].s, NULL), yyvsp[-1].r.end);

	  yyval.t = mk_loop(init, exit, increment, yyvsp[0].t);
	}
    break;

  case 60:
#line 523 "parse.y"
    {
	  yyval.t= mk_loop(NULL, yyvsp[-1].t, NULL, yyvsp[0].t);	
	}
    break;

  case 61:
#line 528 "parse.y"
    {
	  yyval.t= mk_loop(NULL, NULL, NULL, yyvsp[0].t);
	}
    break;

  case 62:
#line 533 "parse.y"
    {
	  yyval.t = yyvsp[-1].t;
	}
    break;

  case 63:
#line 540 "parse.y"
    {
	  /* last statement is elsif */
	  yyval.t = mk_cond(yyvsp[-2].t, yyvsp[0].t, NULL);
	}
    break;

  case 64:
#line 546 "parse.y"
    {
	  yyval.t = mk_cond(yyvsp[-3].t, yyvsp[-1].t, yyvsp[0].t);
	}
    break;

  case 65:
#line 551 "parse.y"
    {
	  /* last statement is else */
	  yyval.t = mk_cond(NULL, yyvsp[0].t, NULL);
	}
    break;

  case 66:
#line 559 "parse.y"
    {
	  /* last statement is elsif equivalent */
	  yyval.t = mk_cond(yyvsp[-2].t, yyvsp[0].t, NULL);
	}
    break;

  case 67:
#line 565 "parse.y"
    {
	  yyval.t = mk_cond(yyvsp[-3].t, yyvsp[-1].t, yyvsp[0].t);
	}
    break;

  case 68:
#line 570 "parse.y"
    {
	  /* last statement is else equivalent */
	  yyval.t = mk_cond(NULL, yyvsp[0].t, NULL);
	}
    break;

  case 69:
#line 578 "parse.y"
    {
	  yyval.t = mk_binop(op_eq, case_ident, yyvsp[0].t);
	}
    break;

  case 70:
#line 583 "parse.y"
    {
	  yyval.t = mk_binop(op_lor, mk_binop(op_eq, case_ident, yyvsp[-2].t), yyvsp[0].t);
	}
    break;

  case 71:
#line 590 "parse.y"
    {
	  yyval.t = mk_symbol(yyvsp[0].s, NULL);
        }
    break;

  case 72:
#line 595 "parse.y"
    {
	  yyval.t = mk_constant(yyvsp[0].i);
	}
    break;

  case 73:
#line 602 "parse.y"
    {
	  yyval.t = yyvsp[-3].t;
	}
    break;

  case 74:
#line 609 "parse.y"
    {
	  yyval.r.start = yyvsp[-2].t;
	  yyval.r.end = yyvsp[0].t;
        }
    break;

  case 75:
#line 617 "parse.y"
    {
	  yyval.t = node_list(yyvsp[0].t, NULL);
	}
    break;

  case 76:
#line 622 "parse.y"
    {
	  yyval.t = node_list(yyvsp[-2].t, yyvsp[0].t);
	}
    break;

  case 79:
#line 633 "parse.y"
    {
	  yyval.t = mk_binop(yyvsp[-1].o, yyvsp[-2].t, yyvsp[0].t);
	}
    break;

  case 80:
#line 638 "parse.y"
    { yyval.o = op_assign; }
    break;

  case 82:
#line 644 "parse.y"
    {
	  yyval.t = mk_binop(yyvsp[-1].o, yyvsp[-2].t, yyvsp[0].t);
	}
    break;

  case 83:
#line 649 "parse.y"
    { yyval.o = op_land; }
    break;

  case 84:
#line 650 "parse.y"
    { yyval.o = op_lor; }
    break;

  case 86:
#line 656 "parse.y"
    {
	  yyval.t = mk_binop(yyvsp[-1].o, yyvsp[-2].t, yyvsp[0].t);
	}
    break;

  case 87:
#line 661 "parse.y"
    { yyval.o = op_and; }
    break;

  case 88:
#line 662 "parse.y"
    { yyval.o = op_or; }
    break;

  case 89:
#line 663 "parse.y"
    { yyval.o = op_xor; }
    break;

  case 91:
#line 669 "parse.y"
    {
	  yyval.t = mk_binop(yyvsp[-1].o, yyvsp[-2].t, yyvsp[0].t);
	}
    break;

  case 92:
#line 674 "parse.y"
    { yyval.o = op_lt; }
    break;

  case 93:
#line 675 "parse.y"
    { yyval.o = op_gt; }
    break;

  case 94:
#line 676 "parse.y"
    { yyval.o = op_eq; }
    break;

  case 95:
#line 677 "parse.y"
    { yyval.o = op_ne; }
    break;

  case 96:
#line 678 "parse.y"
    { yyval.o = op_gte; }
    break;

  case 97:
#line 679 "parse.y"
    { yyval.o = op_lte; }
    break;

  case 99:
#line 685 "parse.y"
    {
	  yyval.t = mk_binop(yyvsp[-1].o, yyvsp[-2].t, yyvsp[0].t);
	}
    break;

  case 100:
#line 690 "parse.y"
    { yyval.o = op_lsh; }
    break;

  case 101:
#line 691 "parse.y"
    { yyval.o = op_rsh; }
    break;

  case 103:
#line 697 "parse.y"
    {
	  yyval.t = mk_binop(yyvsp[-1].o, yyvsp[-2].t, yyvsp[0].t);
	}
    break;

  case 104:
#line 702 "parse.y"
    { yyval.o = op_add; }
    break;

  case 105:
#line 703 "parse.y"
    { yyval.o = op_sub; }
    break;

  case 107:
#line 709 "parse.y"
    {
	  yyval.t = mk_binop(yyvsp[-1].o, yyvsp[-2].t, yyvsp[0].t);
	}
    break;

  case 108:
#line 714 "parse.y"
    { yyval.o = op_mult; }
    break;

  case 109:
#line 715 "parse.y"
    { yyval.o = op_div; }
    break;

  case 110:
#line 716 "parse.y"
    { yyval.o = op_mod; }
    break;

  case 112:
#line 722 "parse.y"
    {
	  yyval.t = mk_unop(yyvsp[-1].o, yyvsp[0].t);
	}
    break;

  case 113:
#line 727 "parse.y"
    { yyval.o = op_neg; }
    break;

  case 114:
#line 728 "parse.y"
    { yyval.o = op_not; }
    break;

  case 115:
#line 729 "parse.y"
    { yyval.o = op_com; }
    break;

  case 116:
#line 730 "parse.y"
    { yyval.o = op_add; }
    break;

  case 117:
#line 734 "parse.y"
    {
	  yyval.t = mk_string(yyvsp[0].s);
        }
    break;

  case 118:
#line 739 "parse.y"
    {
	  yyval.t = mk_symbol(yyvsp[0].s, NULL);
        }
    break;

  case 119:
#line 744 "parse.y"
    {
	  yyval.t = mk_symbol(yyvsp[-3].s, yyvsp[-1].t);
        }
    break;

  case 120:
#line 749 "parse.y"
    {
	  /* function or procedure call */
	  yyval.t = mk_call(yyvsp[-2].s, NULL);
	}
    break;

  case 121:
#line 755 "parse.y"
    {
	  /* function or procedure call with arguments */
	  yyval.t = mk_call(yyvsp[-3].s, yyvsp[-1].t);
	}
    break;

  case 122:
#line 761 "parse.y"
    {
	  yyval.t = mk_constant(yyvsp[0].i);
	}
    break;

  case 123:
#line 766 "parse.y"
    {
	  yyval.t = yyvsp[-1].t;
	}
    break;


    }

/* Line 1000 of yacc.c.  */
#line 2133 "parse.c"

  yyvsp -= yylen;
  yyssp -= yylen;


  YY_STACK_PRINT (yyss, yyssp);

  *++yyvsp = yyval;


  /* Now `shift' the result of the reduction.  Determine what state
     that goes to, based on the state we popped back to and the rule
     number reduced by.  */

  yyn = yyr1[yyn];

  yystate = yypgoto[yyn - YYNTOKENS] + *yyssp;
  if (0 <= yystate && yystate <= YYLAST && yycheck[yystate] == *yyssp)
    yystate = yytable[yystate];
  else
    yystate = yydefgoto[yyn - YYNTOKENS];

  goto yynewstate;


/*------------------------------------.
| yyerrlab -- here on detecting error |
`------------------------------------*/
yyerrlab:
  /* If not already recovering from an error, report this error.  */
  if (!yyerrstatus)
    {
      ++yynerrs;
#if YYERROR_VERBOSE
      yyn = yypact[yystate];

      if (YYPACT_NINF < yyn && yyn < YYLAST)
	{
	  YYSIZE_T yysize = 0;
	  int yytype = YYTRANSLATE (yychar);
	  const char* yyprefix;
	  char *yymsg;
	  int yyx;

	  /* Start YYX at -YYN if negative to avoid negative indexes in
	     YYCHECK.  */
	  int yyxbegin = yyn < 0 ? -yyn : 0;

	  /* Stay within bounds of both yycheck and yytname.  */
	  int yychecklim = YYLAST - yyn;
	  int yyxend = yychecklim < YYNTOKENS ? yychecklim : YYNTOKENS;
	  int yycount = 0;

	  yyprefix = ", expecting ";
	  for (yyx = yyxbegin; yyx < yyxend; ++yyx)
	    if (yycheck[yyx + yyn] == yyx && yyx != YYTERROR)
	      {
		yysize += yystrlen (yyprefix) + yystrlen (yytname [yyx]);
		yycount += 1;
		if (yycount == 5)
		  {
		    yysize = 0;
		    break;
		  }
	      }
	  yysize += (sizeof ("syntax error, unexpected ")
		     + yystrlen (yytname[yytype]));
	  yymsg = (char *) YYSTACK_ALLOC (yysize);
	  if (yymsg != 0)
	    {
	      char *yyp = yystpcpy (yymsg, "syntax error, unexpected ");
	      yyp = yystpcpy (yyp, yytname[yytype]);

	      if (yycount < 5)
		{
		  yyprefix = ", expecting ";
		  for (yyx = yyxbegin; yyx < yyxend; ++yyx)
		    if (yycheck[yyx + yyn] == yyx && yyx != YYTERROR)
		      {
			yyp = yystpcpy (yyp, yyprefix);
			yyp = yystpcpy (yyp, yytname[yyx]);
			yyprefix = " or ";
		      }
		}
	      yyerror (yymsg);
	      YYSTACK_FREE (yymsg);
	    }
	  else
	    yyerror ("syntax error; also virtual memory exhausted");
	}
      else
#endif /* YYERROR_VERBOSE */
	yyerror ("syntax error");
    }



  if (yyerrstatus == 3)
    {
      /* If just tried and failed to reuse lookahead token after an
	 error, discard it.  */

      if (yychar <= YYEOF)
        {
          /* If at end of input, pop the error token,
	     then the rest of the stack, then return failure.  */
	  if (yychar == YYEOF)
	     for (;;)
	       {
		 YYPOPSTACK;
		 if (yyssp == yyss)
		   YYABORT;
		 YYDSYMPRINTF ("Error: popping", yystos[*yyssp], yyvsp, yylsp);
		 yydestruct (yystos[*yyssp], yyvsp);
	       }
        }
      else
	{
	  YYDSYMPRINTF ("Error: discarding", yytoken, &yylval, &yylloc);
	  yydestruct (yytoken, &yylval);
	  yychar = YYEMPTY;

	}
    }

  /* Else will try to reuse lookahead token after shifting the error
     token.  */
  goto yyerrlab1;


/*---------------------------------------------------.
| yyerrorlab -- error raised explicitly by YYERROR.  |
`---------------------------------------------------*/
yyerrorlab:

#ifdef __GNUC__
  /* Pacify GCC when the user code never invokes YYERROR and the label
     yyerrorlab therefore never appears in user code.  */
  if (0)
     goto yyerrorlab;
#endif

  yyvsp -= yylen;
  yyssp -= yylen;
  yystate = *yyssp;
  goto yyerrlab1;


/*-------------------------------------------------------------.
| yyerrlab1 -- common code for both syntax error and YYERROR.  |
`-------------------------------------------------------------*/
yyerrlab1:
  yyerrstatus = 3;	/* Each real token shifted decrements this.  */

  for (;;)
    {
      yyn = yypact[yystate];
      if (yyn != YYPACT_NINF)
	{
	  yyn += YYTERROR;
	  if (0 <= yyn && yyn <= YYLAST && yycheck[yyn] == YYTERROR)
	    {
	      yyn = yytable[yyn];
	      if (0 < yyn)
		break;
	    }
	}

      /* Pop the current state because it cannot handle the error token.  */
      if (yyssp == yyss)
	YYABORT;

      YYDSYMPRINTF ("Error: popping", yystos[*yyssp], yyvsp, yylsp);
      yydestruct (yystos[yystate], yyvsp);
      YYPOPSTACK;
      yystate = *yyssp;
      YY_STACK_PRINT (yyss, yyssp);
    }

  if (yyn == YYFINAL)
    YYACCEPT;

  YYDPRINTF ((stderr, "Shifting error token, "));

  *++yyvsp = yylval;


  yystate = yyn;
  goto yynewstate;


/*-------------------------------------.
| yyacceptlab -- YYACCEPT comes here.  |
`-------------------------------------*/
yyacceptlab:
  yyresult = 0;
  goto yyreturn;

/*-----------------------------------.
| yyabortlab -- YYABORT comes here.  |
`-----------------------------------*/
yyabortlab:
  yyresult = 1;
  goto yyreturn;

#ifndef yyoverflow
/*----------------------------------------------.
| yyoverflowlab -- parser overflow comes here.  |
`----------------------------------------------*/
yyoverflowlab:
  yyerror ("parser stack overflow");
  yyresult = 2;
  /* Fall through.  */
#endif

yyreturn:
#ifndef yyoverflow
  if (yyss != yyssa)
    YYSTACK_FREE (yyss);
#endif
  return yyresult;
}


#line 771 "parse.y"


